import type { TransactionResponse } from '@ethersproject/abstract-provider';
import { Asset, AssetSymbol, WithdrawXTokensConfig } from '@moonbeam-network/xcm-config';
import { Signer } from 'ethers';
export declare class XTokensContract<Symbols extends AssetSymbol = AssetSymbol> {
    #private;
    readonly address: string;
    constructor(signer: Signer);
    transfer(account: string, amount: bigint, asset: Asset<Symbols>, config: WithdrawXTokensConfig<Symbols>): Promise<TransactionResponse>;
    getTransferFees(account: string, amount: bigint, asset: Asset<Symbols>, config: WithdrawXTokensConfig<Symbols>): Promise<bigint>;
    private getGasPrice;
}
