"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _XTokensContract_contract, _XTokensContract_signer;
Object.defineProperty(exports, "__esModule", { value: true });
exports.XTokensContract = void 0;
const ethers_1 = require("ethers");
const XTokensABI_json_1 = __importDefault(require("./XTokensABI.json"));
class XTokensContract {
    constructor(signer) {
        this.address = '0x0000000000000000000000000000000000000804';
        _XTokensContract_contract.set(this, void 0);
        _XTokensContract_signer.set(this, void 0);
        __classPrivateFieldSet(this, _XTokensContract_signer, signer, "f");
        __classPrivateFieldSet(this, _XTokensContract_contract, new ethers_1.Contract(this.address, XTokensABI_json_1.default, signer), "f");
    }
    async transfer(account, amount, asset, config) {
        return __classPrivateFieldGet(this, _XTokensContract_contract, "f").transfer(asset.erc20Id, amount, config.getParams(account), config.weight);
    }
    async getTransferFees(account, amount, asset, config) {
        const estimatedGas = (await __classPrivateFieldGet(this, _XTokensContract_contract, "f").estimateGas.transfer(asset.erc20Id, amount, config.getParams(account), config.weight)).toBigInt();
        const gasPrice = await this.getGasPrice();
        return estimatedGas * gasPrice;
    }
    async getGasPrice() {
        const { gasPrice, maxPriorityFeePerGas } = await __classPrivateFieldGet(this, _XTokensContract_signer, "f").getFeeData();
        return ((gasPrice?.toBigInt() || 0n) + (maxPriorityFeePerGas?.toBigInt() || 0n));
    }
}
exports.XTokensContract = XTokensContract;
_XTokensContract_contract = new WeakMap(), _XTokensContract_signer = new WeakMap();
//# sourceMappingURL=XTokensContract.js.map